// Generated by CoffeeScript 1.4.0
var RE_TRIM,
  __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

RE_TRIM = /^\s+|\s+$/g;

exports.hasClass = function(element, clas) {
  var classes;
  if (element.classList != null) {
    return element.classList.contains(clas);
  } else {
    classes = element.className.replace(RE_TRIM, '').split(' ');
    return __indexOf.call(classes, clas) >= 0;
  }
};

exports.matchClass = function(element, pattern) {
  var clas, classes, _i, _len;
  classes = element.className.replace(RE_TRIM, '').split(' ');
  for (_i = 0, _len = classes.length; _i < _len; _i++) {
    clas = classes[_i];
    if (clas.indexOf(pattern) !== -1) {
      return clas;
    }
  }
  return '';
};

exports.addClass = function(element, clas) {
  if (element.classList != null) {
    return element.classList.add(clas);
  } else {
    return element.className += ' ' + clas;
  }
};

exports.removeClass = function(element, clas) {
  var c, classes;
  if (clas) {
    if (element.classList != null) {
      return element.classList.remove(clas);
    } else {
      classes = (function() {
        var _i, _len, _ref, _results;
        _ref = element.className.replace(RE_TRIM, '').split(' ');
        _results = [];
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          c = _ref[_i];
          if (c !== clas) {
            _results.push(c);
          }
        }
        return _results;
      })();
      return element.className = classes.join(' ');
    }
  }
};

exports.toggleClass = function(element, clas) {
  if (exports.hasClass(element, clas)) {
    return exports.removeClass(element, clas);
  } else {
    return exports.addClass(element, clas);
  }
};

exports.replaceClass = function(element, clasOld, clasNew) {
  if (clasOld) {
    if (clasNew) {
      return element.className = element.className.replace(clasOld, clasNew);
    } else {
      return exports.removeClass(element, clasOld);
    }
  } else if (clasNew) {
    return exports.addClass(element, clasNew);
  }
};

exports.addTemporaryClass = function(element, clas, duration) {
  var _this = this;
  exports.addClass(element, clas);
  return setTimeout((function() {
    return exports.removeClass(element, clas);
  }), duration);
};
