// Generated by CoffeeScript 1.4.0
var RE_IE_OPACITY, RE_RGB, RE_UNITS, VENDOR_PREFIXES, camelCase, clearStyle, colour, current, defaultStyles, doc, expandShorthand, getNumericStyle, getOpacityValue, getPrefixed, getShorthand, getStyle, numeric, objectUtils, opacity, parseNumber, parseOpacity, prefixed, prop, s, setPrefixed, setStyle, shorthand, win, _i, _len;

objectUtils = require('pi/utils/objectutils');

win = window;

doc = win.document;

RE_UNITS = /(px|%|em|ms|s)$/;

RE_IE_OPACITY = /opacity=(\d+)/i;

RE_RGB = /rgb\((\d+),\s?(\d+),\s?(\d+)\)/;

VENDOR_PREFIXES = ['-webkit-', '-moz-', '-ms-', '-o-'];

prefixed = {
  'border-bottom-left-radius': false,
  'border-bottom-right-radius': false,
  'border-top-left-radius': false,
  'border-top-right-radius': false,
  'box-shadow': false,
  'transform': false,
  'transform-origin': false,
  'transform-style': false,
  'transition-delay': false,
  'transition-duration': false,
  'transition-property': false,
  'transition-timing-function': false,
  'perspective': false,
  'perspective-origin': false
};

numeric = {
  'top': 'px',
  'bottom': 'px',
  'left': 'px',
  'right': 'px',
  'width': 'px',
  'height': 'px',
  'margin-top': 'px',
  'margin-bottom': 'px',
  'margin-left': 'px',
  'margin-right': 'px',
  'padding-top': 'px',
  'padding-bottom': 'px',
  'padding-left': 'px',
  'padding-right': 'px',
  'border-bottom-left-radius': 'px',
  'border-bottom-right-radius': 'px',
  'border-top-left-radius': 'px',
  'border-top-right-radius': 'px',
  'transition-duration': 'ms',
  'opacity': '',
  'font-size': 'px'
};

colour = {
  'background-color': 'color',
  'color': 'color',
  'border-color': 'color'
};

shorthand = {
  'border-radius': ['border-bottom-left-radius', 'border-bottom-right-radius', 'border-top-left-radius', 'border-top-right-radius'],
  'border-color': ['border-bottom-color', 'border-left-color', 'border-top-color', 'border-right-color'],
  'margin': ['margin-top', 'margin-right', 'margin-left', 'margin-bottom'],
  'padding': ['padding-top', 'padding-right', 'padding-left', 'padding-bottom']
};

current = function(element, property) {
  if (win.getComputedStyle) {
    if (property) {
      return win.getComputedStyle(element).getPropertyValue(property);
    } else {
      return win.getComputedStyle(element);
    }
  } else {
    if (property) {
      return element.currentStyle[property];
    } else {
      return element.currentStyle;
    }
  }
};

defaultStyles = {};

s = current(doc.documentElement);

if (s.length) {
  for (_i = 0, _len = s.length; _i < _len; _i++) {
    prop = s[_i];
    defaultStyles[prop] = true;
  }
} else {
  for (prop in s) {
    defaultStyles[prop] = true;
  }
}

opacity = !defaultStyles['opacity'] && defaultStyles['filter'] ? 'filter' : 'opacity';

camelCase = function(str) {
  return str.replace(/-([a-z])/g, function($0, $1) {
    return $1.toUpperCase();
  }).replace('-', '');
};

exports.getPrefixed = getPrefixed = function(property) {
  if (prefixed.hasOwnProperty(property)) {
    if (!prefixed[property]) {
      setPrefixed(property);
    }
    property = prefixed[property];
  }
  return property;
};

setPrefixed = function(property) {
  var vendor, _j, _len1, _results;
  if (defaultStyles[property]) {
    prefixed[property] = property;
  }
  _results = [];
  for (_j = 0, _len1 = VENDOR_PREFIXES.length; _j < _len1; _j++) {
    vendor = VENDOR_PREFIXES[_j];
    if (!prefixed[property]) {
      if (defaultStyles[vendor + property]) {
        _results.push(prefixed[property] = vendor + property);
      } else {
        _results.push(void 0);
      }
    }
  }
  return _results;
};

getShorthand = function(property) {
  var _ref;
  return ((_ref = shorthand[property]) != null ? _ref[0] : void 0) || property;
};

expandShorthand = function(property, value) {
  var p, props, _j, _len1, _ref;
  if (shorthand[property] != null) {
    props = {};
    _ref = shorthand[property];
    for (_j = 0, _len1 = _ref.length; _j < _len1; _j++) {
      p = _ref[_j];
      props[p] = value;
    }
    return props;
  }
  return property;
};

parseOpacity = function(element) {
  var match, value;
  value = current(element, opacity);
  if (value === '') {
    return null;
  } else if (opacity === 'filter') {
    match = value.match(RE_IE_OPACITY);
    if (match != null) {
      return parseInt(match[1]) / 100;
    }
  } else {
    return parseFloat(value);
  }
};

getOpacityValue = function(value) {
  var val;
  val = parseFloat(value);
  if (opacity === 'filter') {
    val = "alpha(opacity=" + (val * 100) + ")";
  }
  return val;
};

exports.csstransitions = getPrefixed('transition-duration') !== false;

exports.parseNumber = parseNumber = function(value, property) {
  var channels, num, unit, _ref;
  if (colour[property]) {
    if ((value != null ? value.charAt(0) : void 0) !== '#') {
      channels = RE_RGB.exec(value);
      if (channels) {
        return ["#" + ((1 << 24) | (channels[1] << 16) | (channels[2] << 8) | channels[3]).toString(16).slice(1), 'hex'];
      } else {
        return ['#ffffff', 'hex'];
      }
    } else {
      return [value || '#ffffff', 'hex'];
    }
  } else {
    num = parseFloat(value);
    if (objectUtils.isNaN(num)) {
      return [value, ''];
    } else {
      unit = (_ref = RE_UNITS.exec(value)) != null ? _ref[1] : void 0;
      if (unit == null) {
        unit = numeric[property] != null ? numeric[property] : 'px';
      }
      return [num, unit];
    }
  }
};

exports.getStyle = getStyle = function(element, property) {
  var value;
  if (property === 'opacity') {
    return parseOpacity(element);
  }
  property = getPrefixed(getShorthand(property));
  value = current(element, property);
  if (value == null) {
    value = current(element, camelCase(property));
  }
  switch (value) {
    case '':
      return null;
    case 'auto':
      return 0;
    default:
      return value;
  }
};

exports.getNumericStyle = getNumericStyle = function(element, property) {
  return parseNumber(getStyle(element, property), property);
};

exports.setStyle = setStyle = function(element, property, value) {
  var val;
  property = expandShorthand(property, value);
  if (objectUtils.isObject(property)) {
    for (prop in property) {
      val = property[prop];
      setStyle(element, prop, val);
    }
    return;
  }
  if (property === 'opacity') {
    property = opacity;
    value = getOpacityValue(value);
  }
  property = getPrefixed(property);
  if (value !== 'auto' && value !== 'inherit' && numeric[property] && !RE_UNITS.test(value)) {
    value += numeric[property];
  }
  return element.style[camelCase(property)] = value;
};

exports.clearStyle = clearStyle = function(element, property) {
  var isShorthand, match, re, shortProp, style, _j, _len1;
  isShorthand = shorthand[property] != null;
  shortProp = property;
  property = shorthand[property] || property;
  if (objectUtils.isArray(property)) {
    for (_j = 0, _len1 = property.length; _j < _len1; _j++) {
      prop = property[_j];
      clearStyle(element, prop);
    }
    if (isShorthand) {
      property = shortProp;
    } else {
      return;
    }
  }
  style = element.getAttribute('style') || '';
  re = new RegExp("\\s?" + (getPrefixed(property)) + ":\\s[^;]+");
  match = re.exec(style);
  if (match != null) {
    return element.setAttribute('style', style.replace(match + ';', ''));
  }
};

if (win.testing) {
  exports.getPrefixed = getPrefixed;
  exports.setPrefixed = setPrefixed;
  exports.getShorthand = getShorthand;
  exports.expandShorthand = expandShorthand;
}
