// Generated by CoffeeScript 1.4.0

exports.toComponent = function(colour) {
  var channels, re;
  colour = colour.replace(/[#\s]/g, '');
  if (/^rgb/.test(colour)) {
    re = /^rgb\((\d{1,3}),\s*(\d{1,3}),\s*(\d{1,3})\)$/;
    channels = re.exec(colour);
    return {
      r: parseInt(channels[1], 10),
      g: parseInt(channels[2], 10),
      b: parseInt(channels[3], 10)
    };
  } else if (colour.length === 6) {
    re = /^(\w{2})(\w{2})(\w{2})$/;
    channels = re.exec(colour);
    return {
      r: parseInt(channels[1], 16),
      g: parseInt(channels[2], 16),
      b: parseInt(channels[3], 16)
    };
  } else if (colour.length === 3) {
    re = /^(\w{1})(\w{1})(\w{1})$/;
    channels = re.exec(colour);
    return {
      r: parseInt(channels[1] + channels[1], 16),
      g: parseInt(channels[2] + channels[2], 16),
      b: parseInt(channels[3] + channels[3], 16)
    };
  }
};

exports.rgba = function(colour, alpha) {
  var c;
  c = exports.toComponent(colour);
  return "rgba(" + c.r + "," + c.g + "," + c.b + "," + alpha + ")";
};
