describe 'pi/dom/classList', ->
	classList = require('pi/dom/class_list')
	
	element = document.createElement('div')
	element.className = 'test-class'

	describe 'hasClass()', ->
		it 'should return true if the element has the class', ->
			expect(classList.hasClass(element, 'test-class')).toBeTruthy()

	describe 'addClass()', ->
		it 'should add the class to the element', ->
			classList.addClass(element, 'add-class')
			expect(element.className).toEqual('test-class add-class')

	describe 'removeClass()', ->
		it 'should remove the class from the element', ->
			classList.removeClass(element, 'add-class')
			expect(element.className).toEqual('test-class')
	
	describe 'toggleClass()', ->
		it 'should add the class to the element', ->
			classList.toggleClass(element, 'toggle-class')
			expect(element.className).toEqual('test-class toggle-class')
		it 'should remove the class from the element', ->
			classList.toggleClass(element, 'toggle-class')
			expect(element.className).toEqual('test-class')

	describe 'replaceClass()', ->
		it 'should replace the class with another', ->
			classList.replaceClass(element, 'test-class', 'replace-class')
			expect(element.className).toEqual('replace-class')
	
	
