describe 'pi/utils/objectUtils', ->
	objectUtils = require('pi/utils/object_utils')

	describe 'isObject()', ->
		it 'should return true when passed an Object', ->
			expect(objectUtils.isObject({})).toBeTruthy()

		it 'should return true when passed an Array', ->
			expect(objectUtils.isObject([])).toBeTruthy()

		it 'should return true when passed a Function', ->
			expect(objectUtils.isObject(objectUtils.isObject)).toBeTruthy()

		it 'should return false when passed a String', ->
			expect(objectUtils.isObject('')).toBeFalsy()

		it 'should return false when passed a Number', ->
			expect(objectUtils.isObject(9)).toBeFalsy()

	describe 'isArray()', ->
		it 'should return true when passed an Array', ->
			expect(objectUtils.isArray([])).toBeTruthy()

		it 'should return false when passed an Object', ->
			expect(objectUtils.isArray({})).toBeFalsy()

		it 'should return false when passed a Function', ->
			expect(objectUtils.isArray(objectUtils.isObject)).toBeFalsy()

		it 'should return false when passed a String', ->
			expect(objectUtils.isArray('')).toBeFalsy()

		it 'should return false when passed a Number', ->
			expect(objectUtils.isArray(9)).toBeFalsy()

	describe 'isString()', ->
		it 'should return true when passed a String', ->
			expect(objectUtils.isString('')).toBeTruthy()

		it 'should return false when passed an Array', ->
			expect(objectUtils.isString([])).toBeFalsy()

		it 'should return false when passed an Object', ->
			expect(objectUtils.isString({})).toBeFalsy()

		it 'should return false when passed a Function', ->
			expect(objectUtils.isString(objectUtils.isObject)).toBeFalsy()

		it 'should return false when passed a Number', ->
			expect(objectUtils.isString(9)).toBeFalsy()

	describe 'isNumber()', ->
		it 'should return true when passed a Number', ->
			expect(objectUtils.isNumber(9)).toBeTruthy()

		it 'should return false when passed a String', ->
			expect(objectUtils.isNumber('9')).toBeFalsy()

		it 'should return false when passed an Array', ->
			expect(objectUtils.isNumber([])).toBeFalsy()

		it 'should return false when passed an Object', ->
			expect(objectUtils.isNumber({})).toBeFalsy()

		it 'should return false when passed a Function', ->
			expect(objectUtils.isNumber(objectUtils.isObject)).toBeFalsy()

	describe 'isFunction()', ->
		it 'should return true when passed a Function', ->
			expect(objectUtils.isFunction(objectUtils.isObject)).toBeTruthy()

		it 'should return false when passed a Number', ->
			expect(objectUtils.isFunction(9)).toBeFalsy()

		it 'should return false when passed a String', ->
			expect(objectUtils.isFunction('')).toBeFalsy()

		it 'should return false when passed an Array', ->
			expect(objectUtils.isFunction([])).toBeFalsy()

		it 'should return false when passed an Object', ->
			expect(objectUtils.isFunction({})).toBeFalsy()

	describe 'isNaN()', ->
		it 'should return true when passed NaN', ->
			expect(objectUtils.isNaN(NaN)).toBeTruthy()

		it 'should return false when passed a Function', ->
			expect(objectUtils.isNaN(objectUtils.isObject)).toBeFalsy()

		it 'should return false when passed a Number', ->
			expect(objectUtils.isNaN(9)).toBeFalsy()

		it 'should return false when passed a String', ->
			expect(objectUtils.isNaN('')).toBeFalsy()

		it 'should return false when passed an Array', ->
			expect(objectUtils.isNaN([])).toBeFalsy()

		it 'should return false when passed an Object', ->
			expect(objectUtils.isNaN({})).toBeFalsy()
		