
describe('pi/dom/classList', function() {
  var classList, element;
  classList = require('pi/dom/class_list');
  element = document.createElement('div');
  element.className = 'test-class';
  describe('hasClass()', function() {
    return it('should return true if the element has the class', function() {
      return expect(classList.hasClass(element, 'test-class')).toBeTruthy();
    });
  });
  describe('addClass()', function() {
    return it('should add the class to the element', function() {
      classList.addClass(element, 'add-class');
      return expect(element.className).toEqual('test-class add-class');
    });
  });
  describe('removeClass()', function() {
    return it('should remove the class from the element', function() {
      classList.removeClass(element, 'add-class');
      return expect(element.className).toEqual('test-class');
    });
  });
  describe('toggleClass()', function() {
    it('should add the class to the element', function() {
      classList.toggleClass(element, 'toggle-class');
      return expect(element.className).toEqual('test-class toggle-class');
    });
    return it('should remove the class from the element', function() {
      classList.toggleClass(element, 'toggle-class');
      return expect(element.className).toEqual('test-class');
    });
  });
  return describe('replaceClass()', function() {
    return it('should replace the class with another', function() {
      classList.replaceClass(element, 'test-class', 'replace-class');
      return expect(element.className).toEqual('replace-class');
    });
  });
});
