
describe('pi/utils/objectUtils', function() {
  var objectUtils;
  objectUtils = require('pi/utils/object_utils');
  describe('isObject()', function() {
    it('should return true when passed an Object', function() {
      return expect(objectUtils.isObject({})).toBeTruthy();
    });
    it('should return true when passed an Array', function() {
      return expect(objectUtils.isObject([])).toBeTruthy();
    });
    it('should return true when passed a Function', function() {
      return expect(objectUtils.isObject(objectUtils.isObject)).toBeTruthy();
    });
    it('should return false when passed a String', function() {
      return expect(objectUtils.isObject('')).toBeFalsy();
    });
    return it('should return false when passed a Number', function() {
      return expect(objectUtils.isObject(9)).toBeFalsy();
    });
  });
  describe('isArray()', function() {
    it('should return true when passed an Array', function() {
      return expect(objectUtils.isArray([])).toBeTruthy();
    });
    it('should return false when passed an Object', function() {
      return expect(objectUtils.isArray({})).toBeFalsy();
    });
    it('should return false when passed a Function', function() {
      return expect(objectUtils.isArray(objectUtils.isObject)).toBeFalsy();
    });
    it('should return false when passed a String', function() {
      return expect(objectUtils.isArray('')).toBeFalsy();
    });
    return it('should return false when passed a Number', function() {
      return expect(objectUtils.isArray(9)).toBeFalsy();
    });
  });
  describe('isString()', function() {
    it('should return true when passed a String', function() {
      return expect(objectUtils.isString('')).toBeTruthy();
    });
    it('should return false when passed an Array', function() {
      return expect(objectUtils.isString([])).toBeFalsy();
    });
    it('should return false when passed an Object', function() {
      return expect(objectUtils.isString({})).toBeFalsy();
    });
    it('should return false when passed a Function', function() {
      return expect(objectUtils.isString(objectUtils.isObject)).toBeFalsy();
    });
    return it('should return false when passed a Number', function() {
      return expect(objectUtils.isString(9)).toBeFalsy();
    });
  });
  describe('isNumber()', function() {
    it('should return true when passed a Number', function() {
      return expect(objectUtils.isNumber(9)).toBeTruthy();
    });
    it('should return false when passed a String', function() {
      return expect(objectUtils.isNumber('9')).toBeFalsy();
    });
    it('should return false when passed an Array', function() {
      return expect(objectUtils.isNumber([])).toBeFalsy();
    });
    it('should return false when passed an Object', function() {
      return expect(objectUtils.isNumber({})).toBeFalsy();
    });
    return it('should return false when passed a Function', function() {
      return expect(objectUtils.isNumber(objectUtils.isObject)).toBeFalsy();
    });
  });
  describe('isFunction()', function() {
    it('should return true when passed a Function', function() {
      return expect(objectUtils.isFunction(objectUtils.isObject)).toBeTruthy();
    });
    it('should return false when passed a Number', function() {
      return expect(objectUtils.isFunction(9)).toBeFalsy();
    });
    it('should return false when passed a String', function() {
      return expect(objectUtils.isFunction('')).toBeFalsy();
    });
    it('should return false when passed an Array', function() {
      return expect(objectUtils.isFunction([])).toBeFalsy();
    });
    return it('should return false when passed an Object', function() {
      return expect(objectUtils.isFunction({})).toBeFalsy();
    });
  });
  return describe('isNaN()', function() {
    it('should return true when passed NaN', function() {
      return expect(objectUtils.isNaN(NaN)).toBeTruthy();
    });
    it('should return false when passed a Function', function() {
      return expect(objectUtils.isNaN(objectUtils.isObject)).toBeFalsy();
    });
    it('should return false when passed a Number', function() {
      return expect(objectUtils.isNaN(9)).toBeFalsy();
    });
    it('should return false when passed a String', function() {
      return expect(objectUtils.isNaN('')).toBeFalsy();
    });
    it('should return false when passed an Array', function() {
      return expect(objectUtils.isNaN([])).toBeFalsy();
    });
    return it('should return false when passed an Object', function() {
      return expect(objectUtils.isNaN({})).toBeFalsy();
    });
  });
});
